#ifndef WS2812_H_
#define WS2812_H_
//--------------------------------------------------
#include "stm32f1xx_hal.h"
#include <string.h>
#include <stdlib.h>
#include <stdint.h>
//--------------------------------------------------
#define DELAY_LEN 48
#define BRIGHT 255
#define LED_COUNT 300
#define ARRAY_LEN DELAY_LEN + LED_COUNT*24
#define HIGH 65
#define LOW 26
//--------------------------------------------------
#define BitIsSet(reg, bit) ((reg & (1<<bit)) != 0)
//--------------------------------------------------
typedef struct 
{
    uint16_t H;
    uint8_t S;
    uint8_t V;
} HSV_t;
//--------------------------------------------------
typedef struct 
{
    uint8_t R;
    uint8_t G;
    uint8_t B;
} RGB_t;
//--------------------------------------------------
void ws2812_init(void);
void ws2812_pixel_rgb_to_buf_dma(uint8_t Rpixel , uint8_t Gpixel, uint8_t Bpixel, uint16_t posX);
void ws2812_setValue(void);
void ws2812_light(void);
void ws2812_test01(uint8_t n, uint8_t nm);
void ws2812_test02(uint8_t n, uint8_t nm);
void ws2812_test03(uint8_t n, uint8_t nm);
void ws2812_test04(uint8_t n, uint8_t nm);
void ws2812_test05(uint8_t n, uint8_t nm);
void ws2812_test06(uint8_t n, uint8_t nm);
void ws2812_test07(uint8_t n, uint8_t nm);
void ws2812_test08(uint8_t n, uint8_t nm);
void ws2812_test09(uint8_t n, uint8_t nm);
void ws2812_test10(uint8_t n, uint8_t nm);
void ws2812_test11(uint8_t n, uint8_t col, uint8_t nm);
void ws2812_test12(uint8_t n, uint8_t col, uint8_t nm);
void ws2812_test13(void);
//--------------------------------------------------
#endif /* WS2812_H_ */
